=== debian/changelog ===
simdjson (1.0.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 24 Nov 2021 16:06:14 -0500

simdjson (1.0.2-1) experimental; urgency=medium

  * New upstream version 1.0.2 (Closes: #984332)
  * Update CMake flags to correctly build.
  * Upstream bumped ABI/SO version to 9.

 -- Mo Zhou <lumin@debian.org>  Sat, 13 Nov 2021 15:27:58 -0500

simdjson (0.8.1-1~exp1) experimental; urgency=medium

  * New upstream version 0.8.1
  * Bump SOVERSION from 5 -> 7, and reflect the changein install files.
  * Get rid of the symbols control file for arm64 and ppc64el.

 -- Mo Zhou <lumin@debian.org>  Mon, 01 Feb 2021 14:36:44 +0800
