=== debian/changelog ===
simdjson (2.2.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 07 Oct 2022 10:18:20 -0400

simdjson (2.2.3-1~exp1) experimental; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    and Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Mo Zhou ]
  * New upstream version 2.2.3
  * Install the new pkg-config file.

 -- Mo Zhou <lumin@debian.org>  Sun, 02 Oct 2022 19:36:09 -0400

simdjson (2.2.2-1~exp1) experimental; urgency=medium

  * New upstream version 2.2.2 (July 2022)

 -- Mo Zhou <lumin@debian.org>  Thu, 28 Jul 2022 19:26:05 -0700

simdjson (2.2.1-1~exp1) experimental; urgency=medium

  * New upstream version 2.2.1 (July 2022)

 -- Mo Zhou <lumin@debian.org>  Sun, 24 Jul 2022 22:49:56 -0700

simdjson (2.2.0-1~exp1) experimental; urgency=medium

  * New upstream version 2.2.0
  * Bump SOVERSION from 12 to 13.

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Jul 2022 22:29:07 -0700

simdjson (2.1.0-1~exp1) experimental; urgency=medium

  * New upstream version 2.1.0 (June 2022)
  * Reflect SOVERSION bump to 12.
  * Refresh symbols control file.
  * Copyright: bump year.

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Jul 2022 07:59:11 -0700

simdjson (2.0.1-1~exp1) experimental; urgency=medium

  * New upstream version 2.0.1 (May 2022)
  * Bump SOVERSION to 11.
  * Refresh symbols control file for amd64.
  * Update copyright.

 -- Mo Zhou <lumin@debian.org>  Fri, 17 Jun 2022 22:24:19 -0700
