=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: libs
 Homepage: https://github.com/lemire/simdjson
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian/simdjson
 Vcs-Git: https://salsa.debian.org/debian/simdjson.git
 Maintainer: Mo Zhou <lumin@debian.org>
 Build-Depends: cmake, debhelper-compat (= 13)
 Rules-Requires-Root: no
 
-Package: libsimdjson9
+Package: libsimdjson13
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Parsing gigabytes of JSON per second (shared object)
@@ -37,7 +37,7 @@
 Package: libsimdjson-dev
 Section: libdevel
 Architecture: any
-Depends: libsimdjson9 (= ${binary:Version}), ${misc:Depends}
+Depends: libsimdjson13 (= ${binary:Version}), ${misc:Depends}
 Description: Parsing gigabytes of JSON per second (development)
  JSON is everywhere on the Internet. Servers spend a *lot* of time parsing it.
  We need a fresh approach. The simdjson library uses commonly available SIMD
