=== debian/changelog ===
simdjson (3.0.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Nov 2022 19:59:03 -0500

simdjson (3.0.0-1~exp1) experimental; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libsimdjson13: Add Multi-Arch: same.

  [ Mo Zhou ]
  * New upstream version 3.0.0 (Oct 2022)
  * Bump SOVERSION from 13 to 14.
  * Refresh long package descriptions.
  * Release to experimental.

 -- Mo Zhou <lumin@debian.org>  Wed, 16 Nov 2022 13:39:50 -0500
