=== debian/changelog ===
simdjson (3.0.1-1) unstable; urgency=medium

  * New upstream version 3.0.1 (Nov 2022)

 -- Mo Zhou <lumin@debian.org>  Wed, 23 Nov 2022 11:44:09 -0500
